﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=10
@EndOfDesignText@
#Region  Service Attributes
	#StartAtBoot: False
	
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Private timer2 As Timer
	Private lock As PhoneWakeState
	Private nid As Int = 1
	Private lastzone=9 As Int
	Private MP As MediaPlayer 'should be done in Sub Process_Globals
	Dim	Notification1 As	Notification
End Sub



Sub Service_Start (StartingIntent As Intent)
	Service.StartForeground(nid, CreateNotification("..."))
	Notification1.Initialize2(Notification1.IMPORTANCE_LOW)
'	Notification1.Initialize
	Notification1.Vibrate = False
	Notification1.AutoCancel = True
	Notification1.Sound = False

End Sub


Sub Service_Create
	Service.AutomaticForegroundMode = Service.AUTOMATIC_FOREGROUND_NEVER 'we are handling it ourselves

	lock.PartialLock
	timer2.Initialize("timer",1000)
	timer2.enabled=True
	MP.Initialize2("MP")
End Sub

'Sub Service_Start (StartingIntent As Intent)
''	Service.StartForeground(nid, CreateNotification("..."))
''	StartServiceAt(Me, DateTime.Now + 30 * DateTime.TicksPerMinute, True)
''	Track
'End Sub
Sub Play (name As String)
	
	Private country As String
	Log(Main.Locale)
	Select Case Main.Locale
		Case 	Translations.NED
			country="nl_"
		Case 	Translations.frans
			country="fr_"
		Case 	Translations.duits
			country="de_"
		Case	Translations.POOLS
			country="pl"
		Case Translations.ENGELS
			country="uk"
		Case Else
			country="uk_"


	End Select
	Log(name)
	If File.Exists(File.DirAssets, country & name) Then
		MP.Load(File.DirAssets,country &  name)
	Else
		Log("bestand niet gevonden")
	End If
	''If File.Exists(File.DirRootExternal & "/" & filesb.SoundDirString & country,name)=True Then MP.Load(File.DirRootExternal & "/" & filesb.SoundDirString & country, name)
	MP.Play
End Sub
Sub timer_tick
	Private zone As Int
	If Main.training=False Then Return
	
	Main.elapsedtime=Main.elapsedtime+1
#if test
	Main.testcounter=Main.testcounter+1
	If Main.testcounter>Main.personal.MHR Then Main.testcounter=Main.personal.RHR
	Main.bpm=Main.testcounter
#end if
	
	If Main.bpm>40 Then

		zone=SelectZones
		If lastzone<>zone Then 
			lastzone=zone
			Select zone
				Case 0
					Play("zone0.mp3")
				Case 1
					Play("zone1.mp3")
				Case 2
					Play("zone2.mp3")
				Case 3
					Play("zone3.mp3")
				Case 4
					Play("zone4.mp3")
				Case 5
					Play("zone5.mp3")
			End Select
		End If
		Main.calorie=calculatecalorie3(True)+Main.calorie ''Main.calorie+CalculateColorie(Main.bpm)
		Main.calorie2=Calculatecalorie2(True)+Main.calorie2
		Main.z(zone)=Main.z(zone)+1
		If Main.workout Then
			If Main.bpm>Main.trainingdata.maxhr Then Main.trainingdata.maxhr=Main.bpm
			If Main.bpm<Main.trainingdata.minhr Then Main.trainingdata.minhr=Main.bpm
			Main.trainingdata.duration=Main.elapsedtime
			For x=0 To 5
				Main.trainingdata.z(x)=Main.Z(x)
			Next
			''If elapsedtime Mod 60=0 Then
			Main.trainingdata.bpm.Add(Main.bpm)
			Main.trainingdata.calorie=Main.calorie
			Main.trainingdata.avgbpm=Main.bpm+Main.trainingdata.avgbpm
			''End If
		End If
		Log("running" & Main.elapsedtime)
		CallSub2("main","timer_tick",zone)
	End If
End Sub

Sub SelectZones As Int
	Private s=100*Main.bpm/Main.personal.MHR As Int

'	Log(s)
	For x=0 To Main.zones.Length-1
'		Log(zones(x) & "x" & x)
		
		If s>=Main.zones(x) And s<Main.zones(x+1) Then Return x/2
		x=x+1
	Next
	Return 0
End Sub
'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub
'
'Sub Service_Destroy
'	
''	timer2.Enabled=False
'End Sub
Sub calculatecalorie3(gender As Boolean) As Float
	If gender Then
		Return ((-95.7735 + (0.634 * Main.bpm) + (0.404 * Main.personal.VO2max) + (0.394 * Main.personal.weight) + (0.271 * Main.personal.age))/4.184) / 60
	Else
		
		Return  ((-59.3954 + (0.45 * Main.bpm) + (0.380 * Main.personal.VO2max) + (0.103 * Main.personal.weight) + (0.274 * Main.personal.age))/4.184) / 60
	End If
End Sub

Sub Calculatecalorie2(gender As Boolean) As Float
If gender Then
		Return ((-55.0969 + (0.6309 * Main.bpm) + (0.1988 * Main.personal.weight) + (0.2017 * Main.personal.age))/4.184) /60
Else
		Return ((-20.4022 + (0.4472 * Main.bpm) - (0.1263  * Main.personal.weight) + (0.074 * Main.personal.age))/4.184) /60
End If
End Sub

Sub CalculateColorie(rate As Int) As Float
	'
	Private Calories=(0.380*Main.personal.VO2max+(0.450*rate)+(0.274*Main.personal.age)+(0.0468*Main.personal.weight)-59.3954)/251.04 As Float
	Return Calories
End Sub

Sub CreateNotification (Body As String) As Notification
	Dim notification As Notification
	notification.Initialize2(notification.IMPORTANCE_LOW)
	notification.Icon = "icon"
	notification.SetInfo("heartRateMonitor", Body, Main)
	Return notification
End Sub

Sub Service_Destroy
	timer2.Enabled=False
'	If Tracking Then
	
'		GPS.Stop
'	End If
'	Tracking = False
	lock.ReleasePartialLock
End Sub

